[![Latest Release](https://gitlab.com/alebastr/qmlgreet/-/badges/release.svg)](https://gitlab.com/alebastr/qmlgreet/-/releases)
[![pipeline status](https://gitlab.com/alebastr/qmlgreet/badges/main/pipeline.svg)](https://gitlab.com/alebastr/qmlgreet/-/commits/main)
[![coverage](https://gitlab.com/alebastr/qmlgreet/badges/main/coverage.svg?job=coverage)](https://gitlab.com/alebastr/qmlgreet/)
[![Fedora COPR build status](https://copr.fedorainfracloud.org/coprs/alebastr/greetd/package/qmlgreet/status_image/last_build.png)](https://copr.fedorainfracloud.org/coprs/alebastr/greetd/package/qmlgreet/)

# QmlGreet

A QML-based greeter for [greetd]

## Building

Required dependencies:

- C++ compiler with C++17 support
- CMake (at least 3.8)
- Qt6 or Qt5 with the following components: `Core`, `Network`, `Quick`, `Test`,
  `LinguistTools` (and an extra dependency `QuickControls2` for Qt5)
- (optional) [LayerShellQt] >= 5.25

CMake options:

- `USE_QT_VERSION=<5 or 6>` - Qt version detection is not implemented (deliberately),
  so the desired version should be specified. Defaults to `5`.
- `BUILD_TESTING=<ON|OFF>` - build unit-tests.

## Installing

QmlGreet requires [greetd] and a Wayland compositor.\
An example configuration to use with Sway is available at [data/sway.config](data/sway.config)
and will be installed to a system configuration directory (`/etc/xdg/qmlgreet/sway.config`).

You can enable QmlGreet by telling greetd to start sway with the provided config:

```ini
[default_session]
command = "sway --config /etc/xdg/qmlgreet/sway.config"
```

or just use the [start-qmlgreet](data/start-qmlgreet) wrapper script

```ini
[default_session]
command = "start-qmlgreet"
```

See also greetd documentation at <https://man.sr.ht/~kennylevinsen/greetd/>.

[greetd]: https://sr.ht/~kennylevinsen/greetd/
